VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMFPlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ----==== Const ====----
Private Const VT_EMPTY As Integer = 0

Private Const S_OK As Long = &H0&
Private Const API_TRUE As Long = &H1&
Private Const API_FALSE As Long = &H0&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&

Private Const MF_VERSION As Long = &H1&
Private Const MF_STARTUP_FULL As Long = &H0&

Private Const GUID_NULL As String = "{00000000-0000-0000-0000-000000000000}"

Private Const IID_IMFMediaSource As String = "{279a808d-aec7-40c8-9c6b-a6b492c78a66}"

Private Const MFMediaType_Audio As String = "{73647561-0000-0010-8000-00aa00389b71}"
Private Const MFMediaType_Video As String = "{73646976-0000-0010-8000-00aa00389b71}"

Private Const MF_TOPONODE_SOURCE As String = "{835c58ec-e075-4bc7-bcba-4de000df9ae6}"
Private Const MF_TOPONODE_STREAM_DESCRIPTOR As String = "{835c58ee-e075-4bc7-bcba-4de000df9ae6}"
Private Const MF_TOPONODE_PRESENTATION_DESCRIPTOR As String = "{835c58ed-e075-4bc7-bcba-4de000df9ae6}"

Private Const MF_PD_DURATION As String = "{6C990D33-BB8E-477A-8598-0D5D96FCD88A}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' IUnknown
    QueryInterface = 0
    
    ' IMFSourceResolver
    CreateObjectFromURL = 3
    CreateObjectFromByteStream = 4

    ' IMFAttributes
    GetUINT64 = 8
    SetUnknown = 27
    SetObject = 33
    
    ' IMFActivate
    ShutdownObject = 34
    
    ' IMFMediaSource
    CreatePresentationDescriptor = 8
    Shutdown_Source = 12
    
    ' IMFMediaSession
    SetTopology = 7
    Start_Session = 9
    Pause_Session = 10
    Stop_Session = 11
    Close_Session = 12
    Shutdown_Session = 13
    GetClock = 14
    
    ' IMFTopologyNode
    ConnectOutput = 40
    
    ' IMFTopology
    AddNode = 34
    
    ' IMFMediaTypeHandler
    GetMajorType = 8
    
    ' IMFStreamDescriptor
    GetMediaTypeHandler = 34
    
    ' IMFPresentationDescriptor
    GetStreamDescriptorCount = 33
    GetStreamDescriptorByIndex = 34
    
    ' IMFClock
    GetCorrelatedTime = 4
    GetState = 6
    
End Enum

Private Enum MF_TOPOLOGY_TYPE
    MF_TOPOLOGY_OUTPUT_NODE = &H0&
    MF_TOPOLOGY_SOURCESTREAM_NODE = &H1&
    MF_TOPOLOGY_TRANSFORM_NODE = &H2&
    MF_TOPOLOGY_TEE_NODE = &H3&
End Enum

Private Enum MF_RESOLUTION_TYPE
    MF_RESOLUTION_MEDIASOURCE = &H1&
    MF_RESOLUTION_BYTESTREAM = &H2&
    MF_RESOLUTION_CONTENT_DOES_NOT_HAVE_TO_MATCH_EXTENSION_OR_MIME_TYPE = &H10&
    MF_RESOLUTION_KEEP_BYTE_STREAM_ALIVE_ON_FAIL = &H20&
    MF_RESOLUTION_DISABLE_LOCAL_PLUGINS = &H40&
    MF_RESOLUTION_PLUGIN_CONTROL_POLICY_APPROVED_ONLY = &H80&
    MF_RESOLUTION_PLUGIN_CONTROL_POLICY_WEB_ONLY = &H100&
    MF_RESOLUTION_PLUGIN_CONTROL_POLICY_WEB_ONLY_EDGEMODE = &H200&
    MF_RESOLUTION_ENABLE_STORE_PLUGINS = &H400&
    MF_RESOLUTION_READ = &H10000
    MF_RESOLUTION_WRITE = &H20000
End Enum

Private Enum MF_OBJECT_TYPE
    MF_OBJECT_MEDIASOURCE = &H0&
    MF_OBJECT_BYTESTREAM = &H1&
    MF_OBJECT_INVALID = &H2&
End Enum

Public Enum MFCLOCK_STATE
    MFCLOCK_STATE_INVALID = &H0&
    MFCLOCK_STATE_RUNNING = &H1&
    MFCLOCK_STATE_STOPPED = &H2&
    MFCLOCK_STATE_PAUSED = &H3&
End Enum

' ----==== Type ====----
Private Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Private Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

' ----==== Ole32.dll Deklarationen ====----
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)
                    
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromIID" ( _
                         ByRef pCLSID As GUID, _
                         ByRef lpszProgID As Long) As Long
                         
' ----==== OleAut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long
                         
' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)
                    
Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long
                         
' ----==== Mfplat.dll Deklarationen ====----
Private Declare Function MFStartup Lib "Mfplat.dll" ( _
                         ByVal Version As Long, _
                         ByVal dwFlags As Long) As Long
                         
Private Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Private Declare Function MFCreateSourceResolver Lib "Mfplat.dll" ( _
                         ByRef ppISourceResolver As Long) As Long
                         
Private Declare Function MFCreateMFByteStreamOnStream Lib "Mfplat.dll" ( _
                         ByVal pStream As Long, _
                         ByRef ppByteStream As Long) As Long
                         
' ----==== Mf.dll Deklarationen ====----
Private Declare Function MFCreateMediaSession Lib "Mf.dll" ( _
                         ByVal pConfiguration As Long, _
                         ByRef ppMediaSession As Long) As Long
                         
Private Declare Function MFCreateTopology Lib "Mf.dll" ( _
                         ByRef ppTopo As Long) As Long
                         
Private Declare Function MFCreateTopologyNode Lib "Mf.dll" ( _
                         ByVal NodeType As MF_TOPOLOGY_TYPE, _
                         ByRef ppNode As Long) As Long
                         
Private Declare Function MFCreateAudioRendererActivate Lib "Mf.dll" ( _
                         ByRef ppActivate As Long) As Long
                         
Private Declare Function MFCreateVideoRendererActivate Lib "Mf.dll" ( _
                         ByVal hwndVideo As Long, _
                         ByRef ppActivate As Long) As Long
                         
' ----==== Variablen ====----
Private m_bolMFInit As Boolean

Private m_pIMFClock As Long
Private m_pIMFMediaSource As Long
Private m_pIMFMediaSession As Long

Private m_hRenderWnd As Long
Private m_curDuration As Currency

' ----==== Events ====----
Public Event MediaFileIsReady(ByVal IsReady As Boolean)

Private Sub Class_Initialize()

    m_bolMFInit = False
    
    ' Media Foundation starten
    If MFStartup(MF_VERSION, MF_STARTUP_FULL) = S_OK Then
    
        ' kein VideoRenderer
        m_hRenderWnd = 0&
        
        ' Media Foundation ist gestartet
        m_bolMFInit = True
        
    End If

End Sub

Private Sub Class_Terminate()

    ' ist die Media Foundation gestartet?
    If m_bolMFInit = True Then
    
        ' alles schlieen
        Call CloseMediaSession
    
        ' Media Foundation beenden
        If MFShutdown = S_OK Then
        
            ' Media Foundation ist beendet
            m_bolMFInit = False
            
        End If
    
    End If

End Sub

Public Property Let VideoRenderHwnd(ByVal hWnd As Long)

    If hWnd <> 0& Then
    
        m_hRenderWnd = hWnd
        
    End If

End Property

Public Property Get IsMediaReady() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If m_pIMFMediaSession <> 0& Then
    
        bolRet = True
        
    End If

    IsMediaReady = bolRet

End Property

Public Function PlayMedia() As Boolean

    Dim tPROPVARIANT As PROPVARIANT
    
    ' ist eine MediaSession vorhanden?
    If m_pIMFMediaSession <> 0& Then
    
        ' die Wiedergabe beginnt an der aktuellen Position
        With tPROPVARIANT
            .vt = VT_EMPTY
            .vData = 0&
        End With
        
        ' Wiedergabe starten
        If Invoke(m_pIMFMediaSession, Start_Session, _
            VarPtr(Str2Guid(GUID_NULL)), _
            VarPtr(tPROPVARIANT)) = S_OK Then
            
        End If
        
    End If
    
End Function

Public Function PauseMedia() As Boolean

    ' ist eine MediaSession vorhanden?
    If m_pIMFMediaSession <> 0& Then
    
        ' Wiedergabe stoppen
        If Invoke(m_pIMFMediaSession, Pause_Session) = S_OK Then
        
        End If
        
    End If
    
End Function

Public Function StopMedia() As Boolean

    ' ist eine MediaSession vorhanden?
    If m_pIMFMediaSession <> 0& Then
    
        ' Wiedergabe stoppen
        If Invoke(m_pIMFMediaSession, Stop_Session) = S_OK Then
        
        End If
    End If
    
End Function

Public Property Let MediaFileFromUrl(ByVal sMediaFile As String)

    RaiseEvent MediaFileIsReady(False)
    
    ' Duration = 0
    m_curDuration = 0
        
    ' alles schlieen
    Call CloseMediaSession

    ' Erstellt eine MediaSource von einer Mediadatei/MediaUrl
    If CreateMediaSourceFromUrl(sMediaFile, m_pIMFMediaSource) = True Then
    
        ' Erstellt von der MediaSource eine Wiedergabe-Topologie
        ' und davon eine MediaSession
        If CreatePlaybackTopology(m_pIMFMediaSource, _
            m_pIMFMediaSession, m_pIMFClock, _
            m_curDuration) = True Then
                
            RaiseEvent MediaFileIsReady(True)
                
        End If
    
    End If
    
End Property

Public Property Let MediaFileFromIStream(ByVal pIStream As Long)

    RaiseEvent MediaFileIsReady(False)
    
    ' Duration = 0
    m_curDuration = 0
        
    ' alles schlieen
    Call CloseMediaSession

    ' Erstellt eine MediaSource von einem IStream
    If CreateMediaSourceFromIStream(pIStream, m_pIMFMediaSource) = True Then
    
        ' Erstellt von der MediaSource eine Wiedergabe-Topologie
        ' und davon eine MediaSession
        If CreatePlaybackTopology(m_pIMFMediaSource, _
            m_pIMFMediaSession, m_pIMFClock, _
            m_curDuration) = True Then
                
            RaiseEvent MediaFileIsReady(True)
                
        End If
    
    End If
    
End Property

Public Property Get PlayState() As MFCLOCK_STATE

    Dim lngState As Long
    Dim eRet As MFCLOCK_STATE
    
    eRet = MFCLOCK_STATE_INVALID
    
    If m_pIMFClock <> 0& Then

        If Invoke(m_pIMFClock, GetState, 0&, VarPtr(lngState)) = S_OK Then

            eRet = lngState
            
        End If
        
    End If

    PlayState = eRet

End Property

Public Property Get CurrentPlayPosition() As Currency

    Dim curRet As Currency
    Dim curClockTime As Currency
    Dim curSystemTime As Currency

    If m_pIMFClock <> 0& Then
    
        If Invoke(m_pIMFClock, GetCorrelatedTime, 0&, _
            VarPtr(curClockTime), _
            VarPtr(curSystemTime)) = S_OK Then
        
            curRet = curClockTime * 10000
        
        End If
    
    End If

    CurrentPlayPosition = curRet

End Property

Public Property Get CurrentPlayPositionHMS() As String

    CurrentPlayPositionHMS = CurrencyTime2HMS(Me.CurrentPlayPosition)

End Property

Public Property Get Duration() As Currency

    Duration = m_curDuration

End Property

Public Property Get DurationHMS() As String

    DurationHMS = CurrencyTime2HMS(m_curDuration)
    
End Property

Private Function GetDuration(ByVal pPresentationDescriptor As Long) As Currency

    Dim curRet As Currency
    Dim curValue As Currency

    If pPresentationDescriptor <> 0& Then

        If Invoke(pPresentationDescriptor, GetUINT64, VarPtr(Str2Guid( _
            MF_PD_DURATION)), VarPtr(curValue)) = S_OK Then

            curRet = curValue * 10000

        End If
    
    End If

    GetDuration = curRet

End Function

' Erstellt eine MediaSource von einer Mediadatei
Private Function CreateMediaSourceFromUrl(ByVal sURL As String, _
    ByRef pMediaSource As Long) As Boolean

    Dim bolRet As Boolean
    Dim pIUnknown As Long
    Dim pIMFMediaSource As Long
    Dim pIMFSourceResolver As Long
    Dim eMFOT As MF_OBJECT_TYPE

    bolRet = False
    
    eMFOT = MF_OBJECT_INVALID

    ' Use the source resolver to create a media source
    If MFCreateSourceResolver(pIMFSourceResolver) = S_OK Then

        ' creating a media source
        If Invoke(pIMFSourceResolver, CreateObjectFromURL, _
            StrPtr(sURL), MF_RESOLUTION_TYPE.MF_RESOLUTION_MEDIASOURCE, _
            0&, VarPtr(eMFOT), VarPtr(pIUnknown)) = S_OK Then
            
            If eMFOT = MF_OBJECT_MEDIASOURCE Then

                ' Get the IMFMediaSource interface from the media source
                If Invoke(pIUnknown, QueryInterface, VarPtr(Str2Guid( _
                    IID_IMFMediaSource)), VarPtr(pIMFMediaSource)) = S_OK Then
                    
                    pMediaSource = pIMFMediaSource
                    
                    bolRet = True

                End If

            End If

            Call Release(pIUnknown)

        End If

        Call Release(pIMFSourceResolver)

    End If

    CreateMediaSourceFromUrl = bolRet

End Function

' Erstellt aus einem IStream eine IMFMediaSource/IMFByteStream
Private Function CreateMediaSourceFromIStream(ByVal pIStream As Long, _
    ByRef pMediaSource As Long) As Boolean
    
    Dim bolRet As Boolean
    Dim pIUnknown As Long
    Dim pIMFByteStream As Long
    Dim pIMFMediaSource As Long
    Dim pIMFSourceResolver As Long
    Dim eObjectType As MF_OBJECT_TYPE
    
    bolRet = False
    
    eObjectType = MF_OBJECT_INVALID
    
    ' IMFSourceResolver erstellen
    If MFCreateSourceResolver(pIMFSourceResolver) = S_OK Then
                
        ' vom IStream ein IMFByteStream erstellen
        If MFCreateMFByteStreamOnStream(pIStream, pIMFByteStream) = S_OK Then
        
            ' vom IMFSourceResolver aus dem IMFByteStream ein IUnknown erstellen
            If Invoke(pIMFSourceResolver, CreateObjectFromByteStream, pIMFByteStream, _
                0&, MF_RESOLUTION_TYPE.MF_RESOLUTION_MEDIASOURCE Or _
                MF_RESOLUTION_TYPE.MF_RESOLUTION_CONTENT_DOES_NOT_HAVE_TO_MATCH_EXTENSION_OR_MIME_TYPE, _
                0&, VarPtr(eObjectType), VarPtr(pIUnknown)) = S_OK Then
                    
                ' ist es ein MediaSourcen-Objekt
                If eObjectType = MF_OBJECT_MEDIASOURCE Then
                    
                    ' vom IUnknown eine IMFMediaSource erstellen
                    If Invoke(pIUnknown, QueryInterface, _
                        VarPtr(Str2Guid(IID_IMFMediaSource)), _
                        VarPtr(pIMFMediaSource)) = S_OK Then
                            
                        ' IMFMediaSource zurckgeben
                        pMediaSource = pIMFMediaSource
                        
                        ' alles OK
                        bolRet = True
                            
                    End If
                        
                End If
                    
                ' IUnknown lschen
                Call Release(pIUnknown)
                    
            End If
        
            ' IMFByteStream lschen
            Call Release(pIMFByteStream)
        
        End If
                
        ' IMFSourceResolver lschen
        Call Release(pIMFSourceResolver)
        
    End If
    
    CreateMediaSourceFromIStream = bolRet
    
End Function

' Erstellt von einer MediaSource eine Wiedergabe-Topologie
' und davon eine MediaSession
Private Function CreatePlaybackTopology(ByVal pMediaSource As Long, _
    ByRef pMediaSession As Long, ByRef pClock As Long, _
    ByRef cDuration As Currency) As Boolean

    Dim bolRet As Boolean
    Dim lngDescriptorItem As Long
    Dim lngDescriptorCount As Long
    Dim pIMFClock As Long
    Dim pIMFTopology As Long
    Dim pIMFMediaSession As Long
    Dim pIMFPresentationDescriptor As Long
    
    bolRet = False
    
    ' von der MediaSource einen PresentationDescriptor erstellen
    If Invoke(pMediaSource, CreatePresentationDescriptor, _
        VarPtr(pIMFPresentationDescriptor)) = S_OK Then
        
        ' eine Topologie erstellen
        If MFCreateTopology(pIMFTopology) = S_OK Then
            
            ' Anzahl der StreamDescriptor vom PresentationDescriptor ermitteln
            If Invoke(pIMFPresentationDescriptor, GetStreamDescriptorCount, _
                VarPtr(lngDescriptorCount)) = S_OK Then
                
                ' ist mindestens ein StreamDescriptor vorhanden?
                If lngDescriptorCount > 0& Then
                
                    ' alle StreamDescriptoren durchlaufen
                    For lngDescriptorItem = 0 To lngDescriptorCount - 1
                        
                        bolRet = False
                        
                        ' komplette Topologie von Source bis Output zusammenbauen
                        bolRet = AddBranchToPartialTopology(pMediaSource, _
                            lngDescriptorItem, pIMFPresentationDescriptor, _
                            pIMFTopology)
                            
                    Next lngDescriptorItem
                    
                    ' war das zusammenbauen erfolgreich?
                    If bolRet = True Then
                    
                        bolRet = False
                        
                        ' eine MediaSession erstellen
                        If MFCreateMediaSession(0&, pIMFMediaSession) = S_OK Then
                        
                            ' Topologie der MediaSession zuweisen
                            If Invoke(pIMFMediaSession, SetTopology, 0&, _
                                pIMFTopology) = S_OK Then
                                
                                ' Clock von der MediaSession erstellen
                                If Invoke(pIMFMediaSession, GetClock, VarPtr(pIMFClock)) = S_OK Then

                                    bolRet = True
        
                                End If
                                
                            End If
                            
                            ' alles ok?
                            If bolRet = True Then
                            
                                ' MediaSession zurckgeben
                                pMediaSession = pIMFMediaSession
                                
                                ' Clock zurckgeben
                                pClock = pIMFClock
                                
                                ' Duration ermitteln
                                cDuration = GetDuration(pIMFPresentationDescriptor)

                            Else
                                
                                ' MediaSession lschen
                                Call Release(pIMFMediaSession)
                                
                                ' Clock lschen
                                Call Release(pIMFClock)
                                
                                ' Duration =0
                                cDuration = 0
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            ' Topologie lschen
            Call Release(pIMFTopology)
            
        End If
        
        ' PresentationDescriptor lschen
        Call Release(pIMFPresentationDescriptor)
        
    End If
    
    CreatePlaybackTopology = bolRet
    
End Function

' baut die Topologie von Source bis Output zusammen
Private Function AddBranchToPartialTopology(ByVal pMediaSource As Long, _
    ByVal lngIndex As Long, _
    ByVal pPresentationDescriptor As Long, _
    ByVal pTopology As Long) As Boolean
    
    Dim bolRet As Boolean
    Dim lngSelected As Long
    Dim pIMFStreamDescriptor As Long
    Dim pIMFTopologyNode_Source As Long
    Dim pIMFTopologyNode_Output As Long
    
    bolRet = False
    
    ' vom PresentationDescriptor einen bestimmten StreamDescriptor erstellen
    If Invoke(pPresentationDescriptor, GetStreamDescriptorByIndex, lngIndex, _
        VarPtr(lngSelected), VarPtr(pIMFStreamDescriptor)) = S_OK Then
        
        ' ist der Stream ausgewhlt?
        If lngSelected = API_TRUE Then
        
            ' ein TopologyNode (Source) erstellen
            If CreateSourceNode(pMediaSource, pPresentationDescriptor, _
                pIMFStreamDescriptor, pIMFTopologyNode_Source) = True Then
                
                ' ein TopologyNode (Output) erstellen
                If CreateOutputNode(pIMFStreamDescriptor, _
                    pIMFTopologyNode_Output) = True Then
                    
                    ' TopologyNode (Source) zur Topologie hinzufgen
                    If Invoke(pTopology, AddNode, _
                        pIMFTopologyNode_Source) = S_OK Then
                    
                        ' TopologyNode (Output) zur Topologie hinzufgen
                        If Invoke(pTopology, AddNode, _
                            pIMFTopologyNode_Output) = S_OK Then
                            
                            ' TopologyNode (Source) und TopologyNode (Output)
                            ' miteinander verbinden
                            If Invoke(pIMFTopologyNode_Source, ConnectOutput, _
                                0&, pIMFTopologyNode_Output, 0&) = S_OK Then
                                
                                bolRet = True
                                
                            End If
                            
                        End If
                        
                    End If
                    
                    ' TopologyNode (Output) lschen
                    Call Release(pIMFTopologyNode_Output)
                    
                End If
                
                ' TopologyNode (Source) lschen
                Call Release(pIMFTopologyNode_Source)
                
            End If
            
        End If
        
        ' StreamDescriptor lschen
        Call Release(pIMFStreamDescriptor)
        
    End If
    
    AddBranchToPartialTopology = bolRet
    
End Function

' Erstellt einen entsprechenden Source-TopologyNode
Private Function CreateSourceNode(ByVal pMediaSource As Long, _
    ByVal pPresentationDescriptor As Long, _
    ByVal pStreamDescriptor As Long, _
    ByRef pTopologyNode As Long) As Boolean
    
    Dim bolRet As Boolean
    Dim pIMFTopologyNode As Long

    bolRet = False
    
    ' ein TopologyNode (Source) erstellen
    If MFCreateTopologyNode(MF_TOPOLOGY_SOURCESTREAM_NODE, _
        pIMFTopologyNode) = S_OK Then
                
        ' MediaSource der TopologyNode zuweisen
        If Invoke(pIMFTopologyNode, SetUnknown, _
            VarPtr(Str2Guid(MF_TOPONODE_SOURCE)), _
            pMediaSource) = S_OK Then
            
            ' PresentationDescriptor der TopologyNode zuweisen
            If Invoke(pIMFTopologyNode, SetUnknown, _
                VarPtr(Str2Guid(MF_TOPONODE_PRESENTATION_DESCRIPTOR)), _
                pPresentationDescriptor) = S_OK Then
                
                ' StreamDescriptor der TopologyNode zuweisen
                If Invoke(pIMFTopologyNode, SetUnknown, _
                    VarPtr(Str2Guid(MF_TOPONODE_STREAM_DESCRIPTOR)), _
                    pStreamDescriptor) = S_OK Then
                    
                    bolRet = True
                    
                End If
                
            End If
            
        End If
        
        ' alles ok?
        If bolRet = True Then
        
            ' TopologyNode zurckgeben
            pTopologyNode = pIMFTopologyNode
        
        Else
                
            ' TopologyNode lschen
            Call Release(pIMFTopologyNode)
            
        End If
        
    End If
    
    CreateSourceNode = bolRet
    
End Function

' Erstellt einen entsprechenden Output-TopologyNode
Private Function CreateOutputNode(ByVal pStreamDescriptor As Long, _
    ByRef pTopologyNode As Long) As Boolean
    
    Dim bolRet As Boolean
    Dim pIMFActivate As Long
    Dim pIMFTopologyNode As Long
    Dim pIMFMediaTypeHandler As Long
    Dim tGUID As GUID
    
    bolRet = False
    
    ' ein MediaTypeHandler vom StreamDescriptor erstellen
    If Invoke(pStreamDescriptor, GetMediaTypeHandler, _
        VarPtr(pIMFMediaTypeHandler)) = S_OK Then
        
        ' MajorType vom MediaTypeHandler ermitteln
        If Invoke(pIMFMediaTypeHandler, GetMajorType, _
            VarPtr(tGUID)) = S_OK Then
            
            ' ist der MajorType = MFMediaType_Audio?
            If UCase$(Guid2Str(tGUID)) = UCase$(MFMediaType_Audio) Then
                
                ' ein AudioRenderer-Activate erstellen
                If MFCreateAudioRendererActivate(pIMFActivate) <> S_OK Then
                
                    ' MediaTypeHandler lschen
                    Call Release(pIMFMediaTypeHandler)
                
                    Exit Function
                    
                End If
                
            ' ist der MajorType = MFMediaType_Video?
            ElseIf UCase$(Guid2Str(tGUID)) = UCase$(MFMediaType_Video) Then
            
                ' ein VideoRenderer-Activate erstellen
                ' Handle setzen wir auf 0& da wir das Video nicht brauchen!
                If MFCreateVideoRendererActivate(m_hRenderWnd, pIMFActivate) <> S_OK Then

                    ' MediaTypeHandler lschen
                    Call Release(pIMFMediaTypeHandler)
                    
                    Exit Function

                End If
                
            End If
            
            ' ein Output-TopologyNode erstellen
            If MFCreateTopologyNode(MF_TOPOLOGY_OUTPUT_NODE, _
                pIMFTopologyNode) = S_OK Then
                
                ' entsprechendes Activate dem Output-TopologyNode zuweisen
                If Invoke(pIMFTopologyNode, SetObject, _
                    pIMFActivate) = S_OK Then
                
                    bolRet = True
                    
                End If
                
                ' alles ok?
                If bolRet = True Then
        
                    ' TopologyNode zurckgeben
                    pTopologyNode = pIMFTopologyNode
        
                Else
                
                    ' TopologyNode lschen
                    Call Release(pIMFTopologyNode)
            
                End If
                
            End If
            
            ' Activate deaktivieren
            If Invoke(pIMFActivate, ShutdownObject) = S_OK Then
            
                ' Activate lschen
                Call Release(pIMFActivate)
            
            End If
            
        End If
        
        ' MediaTypeHandler lschen
        Call Release(pIMFMediaTypeHandler)
        
    End If
    
    CreateOutputNode = bolRet
    
End Function

Private Sub CloseMediaSession()

    ' ist eine MediaSession vorhanden?
    If m_pIMFMediaSession <> 0& Then
    
        ' Wiedergabe stoppen
        If Invoke(m_pIMFMediaSession, Stop_Session) = S_OK Then
        
        End If
        
    End If
    
    ' ist eine MediaSession vorhanden?
    If m_pIMFMediaSession <> 0& Then
    
        ' MediaSession schlieen
        Call Invoke(m_pIMFMediaSession, Close_Session)
        
    End If
    
    ' ist eine MediaSource vorhanden
    If m_pIMFMediaSource <> 0& Then
    
        ' MediaSource beenden
        If Invoke(m_pIMFMediaSource, Shutdown_Source) = S_OK Then
        
            ' MediaSource lschen
            Call Release(m_pIMFMediaSource)
            
        End If
        
    End If
    
    ' ist eine Clock vorhanden?
    If m_pIMFClock <> 0& Then
    
        ' Clock lschen
        Call Release(m_pIMFClock)
        
    End If
    
    ' ist eine MediaSession vorhanden?
    If m_pIMFMediaSession <> 0& Then
    
        ' MediaSession beenden
        If Invoke(m_pIMFMediaSession, Shutdown_Session) = S_OK Then
        
            ' MediaSession lschen
            Call Release(m_pIMFMediaSession)
            
        End If
        
    End If
    
End Sub

' ----==== Release Interface ====----
Private Sub Release(ByRef pInterface As Long)

    Dim varRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, varRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function Invoke(ByVal pInterface As Long, _
    ByVal vtb As vtb_Interfaces, _
    ParamArray varParam()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, varParam)
        
    End If
    
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lngRet As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim varRet As Variant
    Dim varParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interface vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            varParam = aParam

            ' ist der Variant ein Array
            If IsArray(varParam) Then varParam = varParam(0)

            ' Anzahl der Parameter
            lngCount = UBound(varParam)

            ' alle Parameter durchlaufen
            For lngItem = 0 To lngCount

                ' Typ des Parameter
                oleTyp(lngItem) = VarType(varParam(lngItem))

                ' Pointer auf den Parameter
                olePtr(lngItem) = VarPtr(varParam(lngItem))

            Next lngItem

        End If

        ' Funktion des Interfaces aufrufen
        lngRet = DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lngItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), varRet)
            
        If lngRet <> S_OK Then
            
            'Debug.Print "DispCallFunc Error: 0x" & Hex$(lngRet)
            
        Else
            
            If varRet <> S_OK Then
        
                'Debug.Print "COM Error: 0x" & Hex$(varRet)
            
            End If

        End If

    End If

    OleInvoke = varRet

End Function

' ----==== GUID-String to Structure GUID ====----
Private Function Str2Guid(ByVal strGUID As String) As GUID

    If Len(strGUID) = 38& Then

        Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
    
    End If
    
End Function

' ----==== Structure GUID to GUID-String ====----
Private Function Guid2Str(ByRef tGUID As GUID) As String

    Dim pGUID As Long

    If StringFromGUID(tGUID, pGUID) = S_OK Then

        Guid2Str = Ptr2Str(pGUID)
    
    End If

End Function

' ----==== String-Pointer to String ====----
Private Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lngStrLen As Long
    Dim bytBuffer() As Byte
    
    If lpStrPointer <> 0& Then
    
        lngStrLen = lstrlenW(lpStrPointer) * 2
        
        If lngStrLen > 0 Then
        
            ReDim bytBuffer(lngStrLen - 1)
            
            Call CopyMemory(bytBuffer(0), ByVal lpStrPointer, lngStrLen)
            
            Call CoTaskMemFree(lpStrPointer)
            
            Ptr2Str = CStr(bytBuffer)
            
        End If
        
    End If
    
End Function

' ----==== CurrencyTime2HMS ====----
Public Function CurrencyTime2HMS(ByVal curTime As Currency) As String
    On Error Resume Next
    
    Dim lngHour As Long
    Dim lngMinu As Long
    Dim dblSeco As Double

    dblSeco = CDbl(curTime / 10000000)

    lngHour = dblSeco \ 3600
    dblSeco = dblSeco Mod 3600
    lngMinu = dblSeco \ 60
    dblSeco = dblSeco Mod 60
    
    CurrencyTime2HMS = Format$(lngHour, "00") & ":" & _
                       Format$(lngMinu, "00") & ":" & _
                       Format$(dblSeco, "00")

End Function
