Attribute VB_Name = "modInterface"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const NO_ERROR As Long = &H0&
Public Const API_TRUE As Long = &H1&
Public Const API_FALSE As Long = &H0&
Public Const STGM_READ As Long = &H0&
Public Const CC_STDCALL As Long = &H4&
Public Const IID_Release As Long = &H8&
Public Const GMEM_MOVEABLE As Long = &H2&
Public Const ERROR_PATH_NOT_FOUND As Long = &H80070003
Public Const ERROR_INVALID_PARAMETER As Long = &H80070057
Public Const STG_E_INSUFFICIENTMEMORY As Long = &H80030008

Public Const IID_IStream As String = "{0000000c-0000-0000-c000-000000000046}"
Public Const IID_IShellItem As String = "{43826d1e-e718-42ee-bc55-a1e261c37bfe}"

Public Const BHID_Stream As String = "{1cebb3ab-7c10-499a-a417-92ca16c4cb83}"

' ----==== Enums ====----
Public Enum vtb_Interfaces

    ' IUnknown
    QueryInterface = 0
    
    ' IShellItem
    BindToHandler = 3
    
    ' IStream
    Write_Stream = 4

End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

' ----==== Shlwapi.dll Deklarationen ====----
Public Declare Function SHCreateItemFromParsingName Lib "Shell32.dll" ( _
                        ByVal pszPath As Long, _
                        ByVal pbc As Long, _
                        ByVal riid As Long, _
                        ByRef ppv As Long) As Long

' ----==== Shlwapi.dll Deklarationen ====----
Public Declare Function SHCreateMemStream Lib "Shlwapi.dll" ( _
                        ByVal pInit As Long, _
                        ByVal cbInit As Long) As Long

Public Declare Function SHCreateStreamOnFileEx Lib "Shlwapi.dll" ( _
                        ByVal pszFile As Long, _
                        ByVal grfMode As Long, _
                        ByVal dwAttributes As Long, _
                        ByVal fCreate As Long, _
                        ByVal pstmTemplate As Long, _
                        ByRef ppstm As Long) As Long

' ----==== Ole32.dll Deklarationen ====----
Public Declare Function CreateStreamOnHGlobal Lib "Ole32.dll" ( _
                        ByVal hGlobal As Long, _
                        ByVal fDeleteOnRelease As Long, _
                        ByRef ppstm As Long) As Long

Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)
                    
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromIID" ( _
                         ByRef pCLSID As GUID, _
                         ByRef lpszProgID As Long) As Long
                         
' ----==== OleAut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long
                         
' ----==== Kernel32.dll Deklarationen ====----
Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)
                    
Public Declare Function GlobalAlloc Lib "Kernel32.dll" ( _
                        ByVal wFlags As Long, _
                        ByVal dwBytes As Long) As Long
                         
Public Declare Function GlobalFree Lib "Kernel32.dll" ( _
                        ByVal hMem As Long) As Long
                         
Public Declare Function GlobalLock Lib "Kernel32.dll" ( _
                        ByVal hMem As Long) As Long
                         
Public Declare Function GlobalUnlock Lib "Kernel32.dll" ( _
                        ByVal hMem As Long) As Long
                    
' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim varRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, varRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Public Function Invoke(ByVal pInterface As Long, _
    ByVal vtb As vtb_Interfaces, _
    ParamArray varParam()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, varParam)
        
    End If
    
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lngRet As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim varRet As Variant
    Dim varParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interface vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            varParam = aParam

            ' ist der Variant ein Array
            If IsArray(varParam) Then varParam = varParam(0)

            ' Anzahl der Parameter
            lngCount = UBound(varParam)

            ' alle Parameter durchlaufen
            For lngItem = 0 To lngCount

                ' Typ des Parameter
                oleTyp(lngItem) = VarType(varParam(lngItem))

                ' Pointer auf den Parameter
                olePtr(lngItem) = VarPtr(varParam(lngItem))

            Next lngItem

        End If

        ' Funktion des Interfaces aufrufen
        lngRet = DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lngItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), varRet)
            
        If lngRet <> S_OK Then
            
            'Debug.Print "DispCallFunc Error: 0x" & Hex$(lngRet)
            
        Else
            
            If varRet <> S_OK Then
        
                'Debug.Print "COM Error: 0x" & Hex$(varRet)
            
            End If

        End If

    End If

    OleInvoke = varRet

End Function

' ----==== GUID-String to Structure GUID ====----
Public Function Str2Guid(ByVal strGUID As String) As GUID

    If Len(strGUID) = 38& Then

        Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
    
    End If
    
End Function

' ----==== Structure GUID to GUID-String ====----
Public Function Guid2Str(ByRef tGUID As GUID) As String

    Dim pGUID As Long

    If StringFromGUID(tGUID, pGUID) = S_OK Then

        Guid2Str = Ptr2Str(pGUID)
    
    End If

End Function

' ----==== String-Pointer to String ====----
Public Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lngStrLen As Long
    Dim bytBuffer() As Byte
    
    If lpStrPointer <> 0& Then
    
        lngStrLen = lstrlenW(lpStrPointer) * 2
        
        If lngStrLen > 0 Then
        
            ReDim bytBuffer(lngStrLen - 1)
            
            Call CopyMemory(bytBuffer(0), ByVal lpStrPointer, lngStrLen)
            
            Call CoTaskMemFree(lpStrPointer)
            
            Ptr2Str = CStr(bytBuffer)
            
        End If
        
    End If
    
End Function

